#include "new_sch.h"

int sch_str(const char *path, const char *file, const char *string)
{
	DIR	*dp;			// directory pointer
	struct object obj;	// search object

	/* open directory stream */
	if( (dp = opendir(path)) == NULL )	{	// none exist directory
		perror(path);	// stderror
		exit(1);
	}

	/* insert search entry */
	strcpy(obj.path, path);		// directory
	strcpy(obj.file, file);		// filename
	strcpy(obj.str, string);	// pattern
	
	sch_out.cnt = 0;			// initial value 0

	list(dp, obj);	// call list()

	return 0;
}

int list(DIR *dp, struct object obj)
{
	DIR				*dp_wk;		// directory pointer for recursive list function
	struct dirent 	*entry;		// get directory status
	struct stat 	dir_stat;	// get path(variable) status
	char 			file[SIZE];	// path(variable)/entry->d_name(variable);
   	struct stat		file_stat;	// get file(variable) status
	struct object 	obj_wk;

	/* read directory pointer */
	while( (entry = readdir(dp)) != NULL )	// until point is not null
	{
		if( strcmp(entry->d_name, ".") == 0 || strcmp(entry->d_name, "..") == 0 )
			continue;
		
		// attach string ;; path/entry->d_name
		if(obj.path[strlen(obj.path)-1] == '/')	{
			// exist '/' befor path(variable)	
			sprintf(file, "%s%s", obj.path, entry->d_name);
		}
		else	{
			// not exist
			sprintf(file, "%s/%s", obj.path, entry->d_name);
		}
		
		if( lstat(file, &file_stat) == -1 )	{	// file(variable) status
			perror(file);
			return -1;
		}

		// file(variable) is file
		if( S_ISREG(file_stat.st_mode) )	{

		//printf("This is File!!!!!!!!!: %s\n",file);
			/*********** !!COMPARE!! **********/
			if( strcmp(entry->d_name, obj.file) == 0 )
			{
				/********** Function 1 . compare filename **********/
				compare_str(obj);
			}		
		}
	
		// file(variable) is directory
		if( S_ISDIR(file_stat.st_mode) )	{			
	
		//printf("This is Directory!!!!!!!!!:%s\n",file);
			// new search object entry 
			if(strcmp("/proc",file)!=0)
			{
				strcpy(obj_wk.path, file);		// directory
				strcpy(obj_wk.file, obj.file);	// filename
				strcpy(obj_wk.str, obj.str);	// string
	
				dp_wk = opendir(obj_wk.path);	// open sub directory stream
				list(dp_wk, obj_wk);			// recursive list() call
			}
		}
	}
	
	closedir(dp);	// close directory stream
	
	return 0;
}

int compare_str(struct object obj)
{
	FILE 	*fp;			// file discripter
	char 	tmp[SIZE];		// file document buffer
	char 	path[SIZE];		// directory path buffer
	char	c;
	int 	cnt = 0;
	
	memset(path, 0, sizeof(path));
	memset(tmp, 0, sizeof(tmp));
	
	sprintf(path, "%s/%s", obj.path, obj.file);
	
	fp = fopen(path, "r");	// file discripter open
	
	while( (c = fgetc(fp)) != EOF )
	{
		tmp[cnt] = c;
		
		if( strstr(tmp, obj.str) != NULL)	{	// check exist string
			strcpy(sch_out.path[sch_out.cnt], obj.path);	// store matched path
			sch_out.cnt++;	// number of matched path
			break;	// find it! break			
		}
		cnt++;

		// a sentence in file can't exceed SIZE
		if(cnt > SIZE - 1 || c == '\n')	{
			memset(tmp, 0, sizeof(tmp));
			cnt = 0;
		}
	}
	
	fclose(fp);	// file discripter close

	return 0;
}
